#ifndef transform_h
#define transform_h

class Transform {
 protected:

  int size;    // size is the size of the array
  int p;       // p is the log2 of the size
  float ** data; // pointer to a pointer to a row (2D array)
  float check_size (float new_size, int orig);
  int threshold_value;

 public:

  // contructor/deconstructor
  Transform(int);
  ~Transform();

  // functions
  float value(int x, int y);
  void print();
  void set_threshold(int new_thresh);
  float Abs(float Nbr);

  void transform (float * new_array, float * out_array);
  void itransform (float * new_array, float * out_array);

  // inherited functions to be overwritted
  virtual void create() =0;
  virtual void scale_to(float *) =0;   // scale waveform to this transform
  virtual void scale_from(float *) =0; // scale from this transform to waveform
  virtual void threshold(float *) =0;  // threshold an array of transformed values
};

#endif
